<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormOfPaymentCheckInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FormOfPaymentCheckInfo
 * @subpackage Structs
 */
class FormOfPaymentCheckInfo extends FormOfPaymentBankInfo
{
    /**
     * The CheckNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CheckNumber;
    /**
     * Constructor method for FormOfPaymentCheckInfo
     * @uses FormOfPaymentCheckInfo::setCheckNumber()
     * @param string $checkNumber
     */
    public function __construct($checkNumber = null)
    {
        $this
            ->setCheckNumber($checkNumber);
    }
    /**
     * Get CheckNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCheckNumber()
    {
        return isset($this->CheckNumber) ? $this->CheckNumber : null;
    }
    /**
     * Set CheckNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $checkNumber
     * @return \App|C\StructType\FormOfPaymentCheckInfo
     */
    public function setCheckNumber($checkNumber = null)
    {
        // validation for constraint: string
        if (!is_null($checkNumber) && !is_string($checkNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checkNumber, true), gettype($checkNumber)), __LINE__);
        }
        if (is_null($checkNumber) || (is_array($checkNumber) && empty($checkNumber))) {
            unset($this->CheckNumber);
        } else {
            $this->CheckNumber = $checkNumber;
        }
        return $this;
    }
}
