<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormOfPaymentRedirectResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FormOfPaymentRedirectResult
 * @subpackage Structs
 */
class FormOfPaymentRedirectResult extends ApiObject
{
    /**
     * The HtmlForm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $HtmlForm;
    /**
     * The UrlGet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UrlGet;
    /**
     * Constructor method for FormOfPaymentRedirectResult
     * @uses FormOfPaymentRedirectResult::setHtmlForm()
     * @uses FormOfPaymentRedirectResult::setUrlGet()
     * @param string $htmlForm
     * @param string $urlGet
     */
    public function __construct($htmlForm = null, $urlGet = null)
    {
        $this
            ->setHtmlForm($htmlForm)
            ->setUrlGet($urlGet);
    }
    /**
     * Get HtmlForm value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHtmlForm()
    {
        return isset($this->HtmlForm) ? $this->HtmlForm : null;
    }
    /**
     * Set HtmlForm value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $htmlForm
     * @return \App|C\StructType\FormOfPaymentRedirectResult
     */
    public function setHtmlForm($htmlForm = null)
    {
        // validation for constraint: string
        if (!is_null($htmlForm) && !is_string($htmlForm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($htmlForm, true), gettype($htmlForm)), __LINE__);
        }
        if (is_null($htmlForm) || (is_array($htmlForm) && empty($htmlForm))) {
            unset($this->HtmlForm);
        } else {
            $this->HtmlForm = $htmlForm;
        }
        return $this;
    }
    /**
     * Get UrlGet value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrlGet()
    {
        return isset($this->UrlGet) ? $this->UrlGet : null;
    }
    /**
     * Set UrlGet value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $urlGet
     * @return \App|C\StructType\FormOfPaymentRedirectResult
     */
    public function setUrlGet($urlGet = null)
    {
        // validation for constraint: string
        if (!is_null($urlGet) && !is_string($urlGet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urlGet, true), gettype($urlGet)), __LINE__);
        }
        if (is_null($urlGet) || (is_array($urlGet) && empty($urlGet))) {
            unset($this->UrlGet);
        } else {
            $this->UrlGet = $urlGet;
        }
        return $this;
    }
}
