<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrepareBookingModificationRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PrepareBookingModificationRequest
 * @subpackage Structs
 */
class PrepareBookingModificationRequest extends AbstractRequest
{
    /**
     * The DeferredIssuance
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $DeferredIssuance;
    /**
     * The IncludeAllOptionalSpecialServices
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IncludeAllOptionalSpecialServices;
    /**
     * The PromoCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PromoCode;
    /**
     * The UniqueID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\UniqueID
     */
    public $UniqueID;
    /**
     * The Verification
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Verification
     */
    public $Verification;
    /**
     * Constructor method for PrepareBookingModificationRequest
     * @uses PrepareBookingModificationRequest::setDeferredIssuance()
     * @uses PrepareBookingModificationRequest::setIncludeAllOptionalSpecialServices()
     * @uses PrepareBookingModificationRequest::setPromoCode()
     * @uses PrepareBookingModificationRequest::setUniqueID()
     * @uses PrepareBookingModificationRequest::setVerification()
     * @param bool $deferredIssuance
     * @param bool $includeAllOptionalSpecialServices
     * @param string $promoCode
     * @param \App|C\StructType\UniqueID $uniqueID
     * @param \App|C\StructType\Verification $verification
     */
    public function __construct($deferredIssuance = null, $includeAllOptionalSpecialServices = null, $promoCode = null, \App|C\StructType\UniqueID $uniqueID = null, \App|C\StructType\Verification $verification = null)
    {
        $this
            ->setDeferredIssuance($deferredIssuance)
            ->setIncludeAllOptionalSpecialServices($includeAllOptionalSpecialServices)
            ->setPromoCode($promoCode)
            ->setUniqueID($uniqueID)
            ->setVerification($verification);
    }
    /**
     * Get DeferredIssuance value
     * @return bool|null
     */
    public function getDeferredIssuance()
    {
        return $this->DeferredIssuance;
    }
    /**
     * Set DeferredIssuance value
     * @param bool $deferredIssuance
     * @return \App|C\StructType\PrepareBookingModificationRequest
     */
    public function setDeferredIssuance($deferredIssuance = null)
    {
        // validation for constraint: boolean
        if (!is_null($deferredIssuance) && !is_bool($deferredIssuance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($deferredIssuance, true), gettype($deferredIssuance)), __LINE__);
        }
        $this->DeferredIssuance = $deferredIssuance;
        return $this;
    }
    /**
     * Get IncludeAllOptionalSpecialServices value
     * @return bool|null
     */
    public function getIncludeAllOptionalSpecialServices()
    {
        return $this->IncludeAllOptionalSpecialServices;
    }
    /**
     * Set IncludeAllOptionalSpecialServices value
     * @param bool $includeAllOptionalSpecialServices
     * @return \App|C\StructType\PrepareBookingModificationRequest
     */
    public function setIncludeAllOptionalSpecialServices($includeAllOptionalSpecialServices = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeAllOptionalSpecialServices) && !is_bool($includeAllOptionalSpecialServices)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeAllOptionalSpecialServices, true), gettype($includeAllOptionalSpecialServices)), __LINE__);
        }
        $this->IncludeAllOptionalSpecialServices = $includeAllOptionalSpecialServices;
        return $this;
    }
    /**
     * Get PromoCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPromoCode()
    {
        return isset($this->PromoCode) ? $this->PromoCode : null;
    }
    /**
     * Set PromoCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $promoCode
     * @return \App|C\StructType\PrepareBookingModificationRequest
     */
    public function setPromoCode($promoCode = null)
    {
        // validation for constraint: string
        if (!is_null($promoCode) && !is_string($promoCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($promoCode, true), gettype($promoCode)), __LINE__);
        }
        if (is_null($promoCode) || (is_array($promoCode) && empty($promoCode))) {
            unset($this->PromoCode);
        } else {
            $this->PromoCode = $promoCode;
        }
        return $this;
    }
    /**
     * Get UniqueID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\UniqueID|null
     */
    public function getUniqueID()
    {
        return isset($this->UniqueID) ? $this->UniqueID : null;
    }
    /**
     * Set UniqueID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\UniqueID $uniqueID
     * @return \App|C\StructType\PrepareBookingModificationRequest
     */
    public function setUniqueID(\App|C\StructType\UniqueID $uniqueID = null)
    {
        if (is_null($uniqueID) || (is_array($uniqueID) && empty($uniqueID))) {
            unset($this->UniqueID);
        } else {
            $this->UniqueID = $uniqueID;
        }
        return $this;
    }
    /**
     * Get Verification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Verification|null
     */
    public function getVerification()
    {
        return isset($this->Verification) ? $this->Verification : null;
    }
    /**
     * Set Verification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Verification $verification
     * @return \App|C\StructType\PrepareBookingModificationRequest
     */
    public function setVerification(\App|C\StructType\Verification $verification = null)
    {
        if (is_null($verification) || (is_array($verification) && empty($verification))) {
            unset($this->Verification);
        } else {
            $this->Verification = $verification;
        }
        return $this;
    }
}
