<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SegmentOption StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SegmentOption
 * @subpackage Structs
 */
class SegmentOption extends SegmentRef
{
    /**
     * The BookingClasses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfBookingClass
     */
    public $BookingClasses;
    /**
     * Constructor method for SegmentOption
     * @uses SegmentOption::setBookingClasses()
     * @param \App|C\ArrayType\ArrayOfBookingClass $bookingClasses
     */
    public function __construct(\App|C\ArrayType\ArrayOfBookingClass $bookingClasses = null)
    {
        $this
            ->setBookingClasses($bookingClasses);
    }
    /**
     * Get BookingClasses value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfBookingClass|null
     */
    public function getBookingClasses()
    {
        return isset($this->BookingClasses) ? $this->BookingClasses : null;
    }
    /**
     * Set BookingClasses value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfBookingClass $bookingClasses
     * @return \App|C\StructType\SegmentOption
     */
    public function setBookingClasses(\App|C\ArrayType\ArrayOfBookingClass $bookingClasses = null)
    {
        if (is_null($bookingClasses) || (is_array($bookingClasses) && empty($bookingClasses))) {
            unset($this->BookingClasses);
        } else {
            $this->BookingClasses = $bookingClasses;
        }
        return $this;
    }
}
